Index: /branches/version-2_11-dev/data/module/SOAP/Base.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Base.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Base.php	(revision 21410)
@@ -25,7 +25,5 @@
  */
 
-/** Define linebreak sequence for the Mail_Mime package. */
 define('MAIL_MIMEPART_CRLF', "\r\n");
-
 require_once 'PEAR.php';
 
@@ -37,6 +35,6 @@
 }
 
-define('SOAP_LIBRARY_VERSION', '0.12.0');
-define('SOAP_LIBRARY_NAME',    'PEAR-SOAP 0.12.0-beta');
+define('SOAP_LIBRARY_VERSION', '0.11.0');
+define('SOAP_LIBRARY_NAME',    'PEAR-SOAP 0.11.0-beta');
 
 // Set schema version.
@@ -63,7 +61,4 @@
 define('SOAP_DEFAULT_ENCODING',  'UTF-8');
 
-/**
- * @package SOAP
- */
 class SOAP_Base_Object extends PEAR
 {
@@ -121,5 +116,5 @@
         $is_instance = isset($this) && is_a($this, 'SOAP_Base_Object');
         if (is_object($str)) {
-            $fault = $str;
+            $fault =& $str;
         } else {
             if (!$code) {
@@ -127,9 +122,13 @@
             }
             require_once 'SOAP/Fault.php';
-            $fault = new SOAP_Fault($str, $code, $actorURI, $detail, $mode,
-                                    $options);
+            $fault =& new SOAP_Fault($str,
+                                     $code,
+                                     $actorURI,
+                                     $detail,
+                                     $mode,
+                                     $options);
         }
         if ($is_instance) {
-            $this->fault = $fault;
+            $this->fault =& $fault;
         }
 
@@ -242,5 +241,5 @@
      * Hash with used namespaces.
      *
-     * @var array
+     * @array
      */
     var $_namespaces;
@@ -249,5 +248,5 @@
      * The default namespace.
      *
-     * @var string
+     * @string
      */
     var $_namespace;
@@ -288,40 +287,4 @@
 
     /**
-     * Sets the SOAP-ENV prefix and returns the current value.
-     *
-     * @access public
-     *
-     * @param string SOAP-ENV prefix
-     *
-     * @return string current SOAP-ENV prefix.
-     */
-    function SOAPENVPrefix($prefix = null)
-    {
-        static $_soapenv_prefix = 'SOAP-ENV';
-        if (!is_null($prefix)) {
-            $_soapenv_prefix = $prefix;
-        }
-        return $_soapenv_prefix;
-    }
-
-    /**
-     * Sets the SOAP-ENC prefix and returns the current value.
-     *
-     * @access public
-     *
-     * @param string SOAP-ENC prefix
-     *
-     * @return string current SOAP-ENC prefix.
-     */
-    function SOAPENCPrefix($prefix = null)
-    {
-        static $_soapenv_prefix = 'SOAP-ENC';
-        if (!is_null($prefix)) {
-            $_soapenv_prefix = $prefix;
-        }
-        return $_soapenv_prefix;
-    }
-
-    /**
      * Sets the default namespace.
      *
@@ -336,8 +299,8 @@
     {
         $this->_namespaces = array(
-            'http://schemas.xmlsoap.org/soap/envelope/' => SOAP_BASE::SOAPENVPrefix(),
+            'http://schemas.xmlsoap.org/soap/envelope/' => 'SOAP-ENV',
             'http://www.w3.org/2001/XMLSchema' => 'xsd',
             'http://www.w3.org/2001/XMLSchema-instance' => 'xsi',
-            'http://schemas.xmlsoap.org/soap/encoding/' => SOAP_BASE::SOAPENCPrefix());
+            'http://schemas.xmlsoap.org/soap/encoding/' => 'SOAP-ENC');
     }
 
@@ -384,33 +347,26 @@
     }
 
-    /**
-     * Serializes a value, array or object according to the rules set by this
-     * object.
-     *
-     * @see SOAP_Value
-     *
-     * @param mixed $value       The actual value.
-     * @param QName $name        The value name.
-     * @param QName $type        The value type.
-     * @param array $options     A list of encoding and serialization options.
-     * @param array $attributes  A hash of additional attributes.
-     * @param string $artype     The type of any array elements.
-     */
-    function _serializeValue($value, $name = null, $type = null,
+    function _isSoapValue(&$value)
+    {
+        return is_a($value, 'SOAP_Value');
+    }
+
+    function _serializeValue(&$value, $name = '', $type = false,
+                             $elNamespace = null, $typeNamespace = null,
                              $options = array(), $attributes = array(),
                              $artype = '')
     {
-        $namespaces  = array();
-        $arrayType   = $array_depth = $xmlout_value = null;
-        $typePrefix  = $elPrefix = $xmlout_arrayType = '';
+        $namespaces = array();
+        $arrayType = $array_depth = $xmlout_value = null;
+        $typePrefix = $elPrefix = $xmlout_offset = $xmlout_arrayType = '';
         $xmlout_type = $xmlns = $ptype = $array_type_ns = '';
 
-        if (!$name->name || is_numeric($name->name)) {
-            $name->name = 'item';
+        if (!$name || is_numeric($name)) {
+            $name = 'item';
         }
 
         if ($this->_wsdl) {
             list($ptype, $arrayType, $array_type_ns, $array_depth)
-                = $this->_wsdl->getSchemaType($type, $name);
+                = $this->_wsdl->getSchemaType($type, $name, $typeNamespace);
         }
 
@@ -422,11 +378,16 @@
         }
         if (!$type) {
-            $type = new QName($ptype);
+            $type = $ptype;
         }
 
         if (strcasecmp($ptype, 'Struct') == 0 ||
-            strcasecmp($type->name, 'Struct') == 0) {
+            strcasecmp($type, 'Struct') == 0) {
             // Struct
-            $vars = is_object($value) ? get_object_vars($value) : $value;
+            $vars = null;
+            if (is_object($value)) {
+                $vars = get_object_vars($value);
+            } else {
+                $vars = &$value;
+            }
             if (is_array($vars)) {
                 foreach (array_keys($vars) as $k) {
@@ -435,5 +396,4 @@
                         continue;
                     }
-
                     if (is_object($vars[$k])) {
                         if (is_a($vars[$k], 'SOAP_Value')) {
@@ -443,15 +403,17 @@
                             // converting to an array is more overhead than we
                             // should really do.
-                            $xmlout_value .= $this->_serializeValue(get_object_vars($vars[$k]), new QName($k, $this->_section5 ? null : $name->namepace), null, $options);
+                            $xmlout_value .= $this->_serializeValue(get_object_vars($vars[$k]), $k, false, $this->_section5 ? null : $elNamespace);
                         }
                     } else {
-                        $xmlout_value .= $this->_serializeValue($vars[$k], new QName($k, $this->_section5 ? null : $name->namespace), false, $options);
+                        $xmlout_value .= $this->_serializeValue($vars[$k], $k, false, $this->_section5 ? null : $elNamespace);
                     }
                 }
             }
         } elseif (strcasecmp($ptype, 'Array') == 0 ||
-                  strcasecmp($type->name, 'Array') == 0) {
+                  strcasecmp($type, 'Array') == 0) {
             // Array.
-            $type = new QName('Array', SOAP_SCHEMA_ENCODING);
+            $typeNamespace = SOAP_SCHEMA_ENCODING;
+            $orig_type = $type;
+            $type = 'Array';
             $numtypes = 0;
             $value = (array)$value;
@@ -477,5 +439,5 @@
                 $ar_size = count($value);
                 foreach ($value as $array_val) {
-                    if (is_a($array_val, 'SOAP_Value')) {
+                    if ($this->_isSoapValue($array_val)) {
                         $array_type = $array_val->type;
                         $array_types[$array_type] = 1;
@@ -485,12 +447,9 @@
                         $array_type = $this->_getType($array_val);
                         $array_types[$array_type] = 1;
-                        if (empty($options['keep_arrays_flat'])) {
-                            $xmlout_value .= $this->_serializeValue($array_val, new QName('item', $this->_section5 ? null : $name->namespace), new QName($array_type), $options);
-                        } else {
-                            $xmlout_value .= $this->_serializeValue($array_val, $name, new QName($array_type), $options, $attributes);
-                        }
+                        $xmlout_value .= $this->_serializeValue($array_val, 'item', $array_type, $this->_section5 ? null : $elNamespace);
                     }
                 }
 
+                $xmlout_offset = ' SOAP-ENC:offset="[0]"';
                 if (!$arrayType) {
                     $numtypes = count($array_types);
@@ -519,6 +478,4 @@
                 } elseif (isset($this->_typemap[$this->_XMLSchemaVersion][$arrayType])) {
                     $array_type_prefix = $this->_namespaces[$this->_XMLSchemaVersion];
-                } elseif (isset($this->_typemap[SOAP_SCHEMA_ENCODING][$arrayType])) {
-                    $array_type_prefix = SOAP_BASE::SOAPENCPrefix();
                 }
                 if ($array_type_prefix) {
@@ -527,6 +484,5 @@
             }
 
-            $xmlout_arrayType = ' ' . SOAP_BASE::SOAPENCPrefix()
-                . ':arrayType="' . $arrayType;
+            $xmlout_arrayType = ' SOAP-ENC:arrayType="' . $arrayType;
             if ($array_depth != null) {
                 for ($i = 0; $i < $array_depth; $i++) {
@@ -535,45 +491,42 @@
             }
             $xmlout_arrayType .= "[$ar_size]\"";
-        } elseif (is_a($value, 'SOAP_Value')) {
+        } elseif ($this->_isSoapValue($value)) {
             $xmlout_value = $value->serialize($this);
-        } elseif ($type->name == 'string') {
+        } elseif ($type == 'string') {
             $xmlout_value = htmlspecialchars($value);
-        } elseif ($type->name == 'rawstring') {
-            $xmlout_value = $value;
-        } elseif ($type->name == 'boolean') {
+        } elseif ($type == 'rawstring') {
+            $xmlout_value =& $value;
+        } elseif ($type == 'boolean') {
             $xmlout_value = $value ? 'true' : 'false';
         } else {
-            $xmlout_value = $value;
+            $xmlout_value =& $value;
         }
 
         // Add namespaces.
-        if ($name->namespace) {
-            $elPrefix = $this->_getNamespacePrefix($name->namespace);
+        if ($elNamespace) {
+            $elPrefix = $this->_getNamespacePrefix($elNamespace);
             if ($elPrefix) {
-                $xmlout_name = $elPrefix . ':' . $name->name;
-            } else {
-                $xmlout_name = $name->name;
+                $xmlout_name = "$elPrefix:$name";
+            } else {
+                $xmlout_name = $name;
             }
         } else {
-            $xmlout_name = $name->name;
-        }
-
-        if ($type->namespace) {
-            $typePrefix = false;
-            if (empty($options['no_type_prefix'])) {
-                $typePrefix = $this->_getNamespacePrefix($type->namespace);
-            }
+            $xmlout_name = $name;
+        }
+
+        if ($typeNamespace) {
+            $typePrefix = $this->_getNamespacePrefix($typeNamespace);
             if ($typePrefix) {
-                $xmlout_type = $typePrefix . ':' . $type->name;
-            } else {
-                $xmlout_type = $type->name;
-            }
-        } elseif ($type->name &&
-                  isset($this->_typemap[$this->_XMLSchemaVersion][$type->name])) {
+                $xmlout_type = "$typePrefix:$type";
+            } else {
+                $xmlout_type = $type;
+            }
+        } elseif ($type &&
+                  isset($this->_typemap[$this->_XMLSchemaVersion][$type])) {
             $typePrefix = $this->_namespaces[$this->_XMLSchemaVersion];
             if ($typePrefix) {
-                $xmlout_type = $typePrefix . ':' . $type->name;
-            } else {
-                $xmlout_type = $type->name;
+                $xmlout_type = "$typePrefix:$type";
+            } else {
+                $xmlout_type = $type;
             }
         }
@@ -604,8 +557,6 @@
             } else {
                 $xml = "\r\n<$xmlout_name$xmlout_type$xmlns$xmlout_arrayType" .
-                    "$xml_attr>$xmlout_value</$xmlout_name>";
-            }
-        } elseif ($type->name == 'Array' && !empty($options['keep_arrays_flat'])) {
-            $xml = $xmlout_value;
+                    "$xmlout_offset$xml_attr>$xmlout_value</$xmlout_name>";
+            }
         } else {
             if (is_null($xmlout_value)) {
@@ -623,9 +574,11 @@
      * Converts a PHP type to a SOAP type.
      *
-     * @param mixed $value  The value to inspect.
+     * @access   private
+     *
+     * @param string $value  The value to inspect.
      *
      * @return string  The value's SOAP type.
      */
-    function _getType($value)
+    function _getType(&$value)
     {
         $type = gettype($value);
@@ -643,20 +596,24 @@
             if ($this->_isHash($value)) {
                 $type = 'Struct';
-                break;
-            }
-            if (count($value) > 1) {
-                // For non-wsdl structs that are all the same type
+            } else {
+                $ar_size = count($value);
                 reset($value);
-                $value1 = next($value);
-                $value2 = next($value);
-                if (is_a($value1, 'SOAP_Value') &&
-                    is_a($value2, 'SOAP_Value') &&
-                    $value1->name != $value2->name) {
-                    // This is a struct, not an array.
-                    $type = 'Struct';
-                    break;
+                $key1 = key($value);
+                if ($ar_size > 0 && is_a($key1, 'SOAP_Value')) {
+                    // FIXME: for non-wsdl structs that are all the same type
+                    $key2 = key($value);
+                    if ($ar_size > 1 &&
+                        $this->_isSoapValue($key1) &&
+                        $this->_isSoapValue($key2) &&
+                        $key1->name != $key2->name) {
+                        // This is a struct, not an array.
+                        $type = 'Struct';
+                    } else {
+                        $type = 'Array';
+                    }
+                } else {
+                    $type = 'Array';
                 }
             }
-            $type = 'Array';
             break;
 
@@ -707,5 +664,5 @@
         } else {
             $type = $this->_getType($value);
-            $xml .= $this->_serializeValue($value, new QName('item'), new QName($type));
+            $xml .= $this->_serializeValue($value, 'item', $type);
         }
         $size = null;
@@ -733,11 +690,20 @@
      * @return boolean  True if the specified array is a hash.
      */
-    function _isHash($a)
-    {
-        foreach (array_keys($a) as $k) {
+    function _isHash(&$a)
+    {
+        // I really dislike having to loop through this in PHP code, really
+        // large arrays will be slow.  We need a C function to do this.
+        $it = 0;
+        foreach ($a as $k => $v) {
             // Checking the type is faster than regexp.
             if (!is_int($k)) {
                 return true;
             }
+            // If someone has a large hash they should really be defining the
+            // type.
+            if ($it++ > 10) {
+                $this->_raiseSoapFault('Large associative array passed where a SOAP_Value was expected');
+                return false;
+            }
         }
         return false;
@@ -752,15 +718,12 @@
 
     /**
-     * Converts a SOAP_Value object into a PHP value.
-     */
-    function _decode($soapval)
-    {
-        if (!is_a($soapval, 'SOAP_Value')) {
+    *   Converts a SOAP_Value object into a StdClass PHP object
+    */
+    function &_decode(&$soapval)
+    {
+        if (!$this->_isSoapValue($soapval)) {
             return $soapval;
-        }
-
-        if (is_array($soapval->value)) {
-            $isstruct = $soapval->type != 'Array';
-            if ($isstruct) {
+        } elseif (is_array($soapval->value)) {
+            if ($soapval->type != 'Array') {
                 $classname = $this->_defaultObjectClassname;
                 if (isset($this->_type_translation[$soapval->tqn->fqn()])) {
@@ -782,11 +745,13 @@
                     }
                 }
-                $return = new $classname;
+                $return =& new $classname;
             } else {
                 $return = array();
             }
 
+            $counter = 1;
+            $isstruct = !is_array($return);
             foreach ($soapval->value as $item) {
-                if ($isstruct) {
+                if (is_object($return)) {
                     if ($this->_wsdl) {
                         // Get this child's WSDL information.
@@ -801,8 +766,8 @@
                         }
                     }
-                    if ($item->type == 'Array') {
+                    if (!$isstruct || $item->type == 'Array') {
                         if (isset($return->{$item->name}) &&
                             is_object($return->{$item->name})) {
-                            $return->{$item->name} = $this->_decode($item);
+                            $return->{$item->name} =& $this->_decode($item);
                         } elseif (isset($return->{$item->name}) &&
                                   is_array($return->{$item->name})) {
@@ -814,18 +779,19 @@
                             );
                         } elseif (is_array($return)) {
-                            $return[] = $this->_decode($item);
+                            $return[] =& $this->_decode($item);
                         } else {
-                            $return->{$item->name} = $this->_decode($item);
+                            $return->{$item->name} =& $this->_decode($item);
                         }
                     } elseif (isset($return->{$item->name})) {
-                        $d = $this->_decode($item);
+                        //$isstruct = false;
                         if (count(get_object_vars($return)) == 1) {
-                            $isstruct = false;
+                            $d =& $this->_decode($item);
                             $return = array($return->{$item->name}, $d);
                         } else {
+                            $d =& $this->_decode($item);
                             $return->{$item->name} = array($return->{$item->name}, $d);
                         }
                     } else {
-                        $return->{$item->name} = $this->_decode($item);
+                        $return->{$item->name} =& $this->_decode($item);
                     }
                     // Set the attributes as members in the class.
@@ -838,5 +804,5 @@
                     }
                 } else {
-                    if ($soapval->arrayType && is_a($item, 'SOAP_Value')) {
+                    if ($soapval->arrayType && $this->_isSoapValue($item)) {
                         if ($this->_isBase64Type($item->type) &&
                             !$this->_isBase64Type($soapval->arrayType)) {
@@ -847,5 +813,13 @@
                         $item->type = $soapval->arrayType;
                     }
-                    $return[] = $this->_decode($item);
+                    if (!$isstruct) {
+                        $return[] = $this->_decode($item);
+                    } elseif (isset($return[$item->name])) {
+                        $isstruct = false;
+                        $d =& $this->_decode($item);
+                        $return = array($return[$item->name], $d);
+                    } else {
+                        $return[$item->name] = $this->_decode($item);
+                    }
                 }
             }
@@ -866,6 +840,4 @@
             settype($soapval->value,
                     $this->_typemap[SOAP_XML_SCHEMA_VERSION][$soapval->type]);
-        } elseif ($soapval->type == 'Struct') {
-            $soapval->value = null;
         }
 
@@ -876,14 +848,13 @@
      * Creates the SOAP envelope with the SOAP envelop data.
      *
-     * @param SOAP_Value $method  SOAP_Value instance with the method name as
-     *                            the name, and the method arguments as the
-     *                            value.
-     * @param array $headers      A list of additional SOAP_Header objects.
-     * @param string $encoding    The charset of the SOAP message.
-     * @param array $options      A list of encoding/serialization options.
-     *
-     * @return string  The complete SOAP message.
-     */
-    function makeEnvelope($method, $headers, $encoding = SOAP_DEFAULT_ENCODING,
+     * @param mixed $method
+     * @param array $headers
+     * @param string $encoding
+     * @param array $options
+     *
+     * @return string
+     */
+    function makeEnvelope(&$method, &$headers,
+                          $encoding = SOAP_DEFAULT_ENCODING,
                           $options = array())
     {
@@ -891,15 +862,15 @@
 
         if ($headers) {
-            for ($i = 0, $c = count($headers); $i < $c; $i++) {
+            $c = count($headers);
+            for ($i = 0; $i < $c; $i++) {
                 $header_xml .= $headers[$i]->serialize($this);
             }
-            $header_xml = sprintf("<%s:Header>\r\n%s\r\n</%s:Header>\r\n",
-                                  SOAP_BASE::SOAPENVPrefix(), $header_xml,
-                                  SOAP_BASE::SOAPENVPrefix());
+            $header_xml = "<SOAP-ENV:Header>\r\n$header_xml\r\n</SOAP-ENV:Header>\r\n";
         }
 
         if (!isset($options['input']) || $options['input'] == 'parse') {
             if (is_array($method)) {
-                for ($i = 0, $c = count($method); $i < $c; $i++) {
+                $c = count($method);
+                for ($i = 0; $i < $c; $i++) {
                     $smsg .= $method[$i]->serialize($this);
                 }
@@ -910,29 +881,22 @@
             $smsg = $method;
         }
-        $body = sprintf("<%s:Body>%s\r\n</%s:Body>\r\n",
-                        SOAP_BASE::SOAPENVPrefix(), $smsg,
-                        SOAP_BASE::SOAPENVPrefix());
+        $body = "<SOAP-ENV:Body>\r\n" . $smsg . "\r\n</SOAP-ENV:Body>\r\n";
 
         foreach ($this->_namespaces as $k => $v) {
-            $ns_string .= "\r\n " . sprintf('xmlns:%s="%s"', $v, $k);
+            $ns_string .= " xmlns:$v=\"$k\"\r\n";
         }
         if ($this->_namespace) {
-            $ns_string .= "\r\n " . sprintf('xmlns="%s"', $this->_namespace);
-        }
-
-        /* If 'use' == 'literal', do not put in the encodingStyle.  This is
+            $ns_string .= " xmlns=\"{$this->_namespace}\"\r\n";
+        }
+
+        /* If 'use' == 'literal', we do not put in the encodingStyle.  This is
          * denoted by $this->_section5 being false.  'use' can be defined at a
          * more granular level than we are dealing with here, so this does not
          * work for all services. */
-        $xml = sprintf('<?xml version="1.0" encoding="%s"?>%s<%s:Envelope%s',
-                       $encoding, "\r\n", SOAP_BASE::SOAPENVPrefix(),
-                       $ns_string);
-        if ($this->_section5) {
-            $xml .= "\r\n " . sprintf('%s:encodingStyle="%s"',
-                                      SOAP_BASE::SOAPENVPrefix(),
-                                      SOAP_SCHEMA_ENCODING);
-        }
-        $xml .= sprintf('>%s%s%s</%s:Envelope>' . "\r\n",
-                        "\r\n", $header_xml, $body, SOAP_BASE::SOAPENVPrefix());
+        $xml = "<?xml version=\"1.0\" encoding=\"$encoding\"?>\r\n\r\n".
+            "<SOAP-ENV:Envelope $ns_string".
+            ($this->_section5 ? ' SOAP-ENV:encodingStyle="' . SOAP_SCHEMA_ENCODING . '"' : '').
+            ">\r\n".
+            "$header_xml$body</SOAP-ENV:Envelope>\r\n";
 
         return $xml;
@@ -953,4 +917,5 @@
         $params['content_type'] = 'text/xml';
         $params['charset'] = $encoding;
+        $params['encoding'] = 'base64';
         $msg->addSubPart($xml, $params);
 
@@ -1001,5 +966,5 @@
 
         // Lame thing to have to do for decoding.
-        $decoder = new Mail_mimeDecode($data);
+        $decoder =& new Mail_mimeDecode($data);
         $structure = $decoder->decode($params);
 
@@ -1013,19 +978,19 @@
             $headers = array_merge($structure->headers,
                                    $structure->parts[0]->headers);
-            if (count($structure->parts) <= 1) {
-                return;
-            }
-
-            $mime_parts = array_splice($structure->parts, 1);
-            // Prepare the parts for the SOAP parser.
-            for ($i = 0, $c = count($mime_parts); $i < $c; $i++) {
-                $p = $mime_parts[$i];
-                if (isset($p->headers['content-location'])) {
-                    // TODO: modify location per SwA note section 3
-                    // http://www.w3.org/TR/SOAP-attachments
-                    $attachments[$p->headers['content-location']] = $p->body;
-                } else {
-                    $cid = 'cid:' . substr($p->headers['content-id'], 1, -1);
-                    $attachments[$cid] = $p->body;
+            if (count($structure->parts) > 1) {
+                $mime_parts = array_splice($structure->parts,1);
+                // Prepare the parts for the SOAP parser.
+
+                $c = count($mime_parts);
+                for ($i = 0; $i < $c; $i++) {
+                    $p =& $mime_parts[$i];
+                    if (isset($p->headers['content-location'])) {
+                        // TODO: modify location per SwA note section 3
+                        // http://www.w3.org/TR/SOAP-attachments
+                        $attachments[$p->headers['content-location']] = $p->body;
+                    } else {
+                        $cid = 'cid:' . substr($p->headers['content-id'], 1, -1);
+                        $attachments[$cid] = $p->body;
+                    }
                 }
             }
@@ -1045,5 +1010,5 @@
         // This SHOULD be moved to the transport layer, e.g. PHP itself should
         // handle parsing DIME ;)
-        $dime = new Net_DIME_Message();
+        $dime =& new Net_DIME_Message();
         $err = $dime->decodeData($data);
         if (PEAR::isError($err)) {
@@ -1071,4 +1036,12 @@
 
     /**
+     * @deprecated Use setTypeTranslation().
+     */
+    function __set_type_translation($type, $class = null)
+    {
+        $this->setTypeTranslation($type, $class);
+    }
+
+    /**
      * Explicitly sets the translation for a specific class.
      *
@@ -1093,4 +1066,5 @@
  * Class used to handle QNAME values in XML.
  *
+ * @access   public
  * @package  SOAP
  * @author   Shane Caraveo <shane@php.net> Conversion to PEAR and updates
@@ -1100,5 +1074,5 @@
     var $name = '';
     var $ns = '';
-    var $namespace = '';
+    var $namespace='';
 
     function QName($name, $namespace = '')
Index: /branches/version-2_11-dev/data/module/SOAP/Fault.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Fault.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Fault.php	(revision 21410)
@@ -24,5 +24,4 @@
  */
 
-/** PEAR_Error */
 require_once 'PEAR.php';
 
@@ -30,13 +29,13 @@
  * PEAR::Error wrapper used to match SOAP Faults to PEAR Errors
  *
- * SOAP_Fault can provide a complete backtrace of the error.  Revealing these
- * details in a public web services is a bad idea because it can be used by
- * attackers.  Thus you have to enable backtrace information in SOAP_Fault
- * responses by putting the following code in your script after your
- * "require_once 'SOAP/Server.php';" line:
+ * SOAP_Fault transmissions normally contain a complete backtrace of the
+ * error.  Revealing these details in a public web services is a bad idea
+ * because it can be used by attackers.  Backtrace information can be kept out
+ * of SOAP_Fault responses by putting the following code in your script after
+ * your "require_once 'SOAP/Server.php';" line:
  *
  * <code>
- * $backtrace =& PEAR::getStaticProperty('SOAP_Fault', 'backtrace');
- * $backtrace = true;
+ * $skiptrace =& PEAR::getStaticProperty('PEAR_Error', 'skiptrace');
+ * $skiptrace = true;
  * </code>
  *
@@ -77,9 +76,8 @@
         $msg = new SOAP_Base();
         $params = array();
-        $params[] = new SOAP_Value('faultcode', 'QName', SOAP_BASE::SOAPENVPrefix().':' . $this->code);
+        $params[] = new SOAP_Value('faultcode', 'QName', 'SOAP-ENV:' . $this->code);
         $params[] = new SOAP_Value('faultstring', 'string', $this->message);
         $params[] = new SOAP_Value('faultactor', 'anyURI', $this->error_message_prefix);
-        if (PEAR::getStaticProperty('SOAP_Fault', 'backtrace') &&
-            isset($this->backtrace)) {
+        if (isset($this->backtrace)) {
             $params[] = new SOAP_Value('detail', 'string', $this->backtrace);
         } else {
